<?php
if (ini_get ("register_globals") == "1")
	die ("Insecure PHP settings detected. Please make sure register_globals is disabled.");

error_reporting (E_NONE);

require_once ('config.php');

if (!isset ($config))
	die ("Config did not load. Please check config.php settings.");
?>

<html>
	<head>
		<title>Image Uploader</title>
	</head>
	<body>
		<h1>Image Uploader</h1>
<?php
if ($_SERVER['REQUEST_METHOD'] == 'GET')
{
?>
		<form method="post" action="<?=$_SERVER['PHP_SELF']?>" enctype="multipart/form-data">
			<p>Select an image to upload (max size: <?=$config['max_size']?> KiB):<br>
			<input type="file" name="filename"></p>
			<p><input type="submit" value="Upload"></p>
		</form>
<?php
}
else
{
	if (!isset($_FILES['filename']) || $_FILES['filename']['tmp_name'] == '')
	{
		$error = "Upload failed, please check the filename and try again.";
	}
	else
	{
		$file = $_FILES['filename']['tmp_name'];

		$file_size = filesize($file) / 1024;
		if ($file_size > $config['max_size'])
			$error = "File size exceeded, maximum allowed file is {$config['max_size']} KiB, your file was " . sprintf ("%.2f", $file_size) . " KiB.";

		if (!isset($error))
		{
			$fh = fopen ($file, "rb");
			if ($fh)
			{
				$header_bytes = fread($fh, 8);

				if (!strncmp ($header_bytes, "\xFF\xD8", 2))
					$file_format = ".jpg";
				else if (!strncmp ($header_bytes, "\x89\x50\x4E\x47\x0D\x0A\x1A\x0A", 8))
					$file_format = ".png";
				else if (!strncmp ($header_bytes, "GIF", 3))
					$file_format = ".gif";
				else
					$error = "Unknown file format, only JPEG, PNG and GIF files are allowed.";

				fclose ($fh);

				if (!isset($error))
				{
					//Remove path
					$user_supplied_filename = basename($_FILES['filename']['name']);

					//Strip extension(s)
					$dot = strpos ($user_supplied_filename, ".");

					if ($dot !== FALSE)
						$user_supplied_filename = substr ($user_supplied_filename, 0, $dot);

					//Rewrite filename if it's invalid
					if ($user_supplied_filename == '' || preg_match ("/\W/", $user_supplied_filename))
						$user_supplied_filename = sha1($file);

					//Check for overwrite prior to extension
					$final_prefix = $config['data_dir'] . "/" . $user_supplied_filename;
					$added = '';
					while (file_exists ($final_prefix . $added . $file_format))
						$added++;

					$final_filename = $final_prefix . $added . $file_format;
					$final_basename = $user_supplied_filename . $added . $file_format;

					//Move it to the upload directory
					if (!move_uploaded_file ($file, $final_filename))
						$error = "Internal error, unable to move uploaded file. Please check permissions and disk space.";
				}
			}
			else
			{
				$error = "Internal error, unable to open uploaded file.";
			}
		}
	}

	if (isset($error))
	{
?>
		<span style="color: #F00"><strong>ERROR:</strong> <?=$error?></span>
		<p><a href=".">Try again</a></p>
<?php
	}
	else
	{
?>
		<p>Your file was uploaded successfully.</p>

		<p>Direct link: <a href="<?=$config['web_dir'] . $final_basename?>"><?=$config['web_dir'] . $final_basename?></a></p>
		<p>Forum code: [img]<?=$config['web_dir'] . $final_basename?>[/img]</p>
<?php
	}
}
?>
</body>
</html>
